/*   -*- buffer-read-only: t -*- vi: set ro:
 *  
 *  DO NOT EDIT THIS FILE   (ntp-keygen-opts.h)
 *  
 *  It has been AutoGen-ed  Tuesday June 27, 2006 at 10:16:55 PM EDT
 *  From the definitions    ntp-keygen-opts.def
 *  and the template file   options
 */
/*
 *  This file contains the programmatic interface to the Automated
 *  Options generated for the ntp-keygen program.
 *  These macros are documented in the AutoGen info file in the
 *  "AutoOpts" chapter.  Please refer to that doc for usage help.
 */
#ifndef AUTOOPTS_NTP_KEYGEN_OPTS_H_GUARD
#define AUTOOPTS_NTP_KEYGEN_OPTS_H_GUARD

/*
 * ntp-keygen copyright 1970-2006 ntp.org - all rights reserved
 *
 * see html/copyright.html
 */
#include "config.h"
#include <autoopts/options.h>

/*
 *  Ensure that the library used for compiling this generated header is at
 *  least as new as the version current when the header template was released
 *  (not counting patch version increments).  Also ensure that the oldest
 *  tolerable version is at least as old as what was current when the header
 *  template was released.
 */
#define AO_TEMPLATE_VERSION 110592
#if (AO_TEMPLATE_VERSION < OPTIONS_MINIMUM_VERSION) \
 || (AO_TEMPLATE_VERSION > OPTIONS_STRUCT_VERSION)
# error option template version mismatches autoopts/options.h header
#endif

/*
 *  Enumeration of each option:
 */
typedef enum {
        INDEX_OPT_CERTIFICATE      =  0,
        INDEX_OPT_DEBUG_LEVEL      =  1,
        INDEX_OPT_SET_DEBUG_LEVEL  =  2,
        INDEX_OPT_ID_KEY           =  3,
        INDEX_OPT_GQ_PARAMS        =  4,
        INDEX_OPT_GQ_KEYS          =  5,
        INDEX_OPT_HOST_KEY         =  6,
        INDEX_OPT_IFFKEY           =  7,
        INDEX_OPT_ISSUER_NAME      =  8,
        INDEX_OPT_MD5KEY           =  9,
        INDEX_OPT_MODULUS          = 10,
        INDEX_OPT_PVT_CERT         = 11,
        INDEX_OPT_PVT_PASSWD       = 12,
        INDEX_OPT_GET_PVT_PASSWD   = 13,
        INDEX_OPT_SIGN_KEY         = 14,
        INDEX_OPT_SUBJECT_NAME     = 15,
        INDEX_OPT_TRUSTED_CERT     = 16,
        INDEX_OPT_MV_PARAMS        = 17,
        INDEX_OPT_MV_KEYS          = 18,
        INDEX_OPT_VERSION          = 19,
        INDEX_OPT_HELP             = 20,
        INDEX_OPT_MORE_HELP        = 21,
        INDEX_OPT_SAVE_OPTS        = 22,
        INDEX_OPT_LOAD_OPTS        = 23
} teOptIndex;

#define OPTION_CT    24
#define NTP_KEYGEN_VERSION       "4.2.3p12"
#define NTP_KEYGEN_FULL_VERSION  "ntp-keygen (ntp) - Create a NTP host key - Ver. 4.2.3p12"

/*
 *  Interface defines for all options.  Replace "n" with
 *  the UPPER_CASED option name (as in the teOptIndex
 *  enumeration above).  e.g. HAVE_OPT( CERTIFICATE )
 */
#define        DESC(n) ntp_keygenOptions.pOptDesc[INDEX_OPT_ ## n]
#define     HAVE_OPT(n) (! UNUSED_OPT(& DESC(n)))
#define      OPT_ARG(n) (DESC(n).pzLastArg)
#define    STATE_OPT(n) (DESC(n).fOptState & OPTST_SET_MASK)
#define    COUNT_OPT(n) (DESC(n).optOccCt)
#define    ISSEL_OPT(n) (SELECTED_OPT(&DESC(n)))
#define ISUNUSED_OPT(n) (UNUSED_OPT(& DESC(n)))
#define  ENABLED_OPT(n) (! DISABLED_OPT(& DESC(n)))
#define  STACKCT_OPT(n) (((tArgList*)(DESC(n).optCookie))->useCt)
#define STACKLST_OPT(n) (((tArgList*)(DESC(n).optCookie))->apzArgs)
#define    CLEAR_OPT(n) STMTS( \
                DESC(n).fOptState &= OPTST_PERSISTENT;   \
                if ( (DESC(n).fOptState & OPTST_INITENABLED) == 0) \
                    DESC(n).fOptState |= OPTST_DISABLED; \
                DESC(n).optCookie = NULL )

/*
 *  Interface defines for specific options.
 */
#ifdef OPENSSL
#define VALUE_OPT_CERTIFICATE    'c'
#endif /* OPENSSL */
#define VALUE_OPT_DEBUG_LEVEL    'd'
#define VALUE_OPT_SET_DEBUG_LEVEL 'D'
#ifdef OPENSSL
#define VALUE_OPT_ID_KEY         'e'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_GQ_PARAMS      'G'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_GQ_KEYS        'g'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_HOST_KEY       'H'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_IFFKEY         'I'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_ISSUER_NAME    'i'
#endif /* OPENSSL */
#define VALUE_OPT_MD5KEY         'M'
#ifdef OPENSSL
#define VALUE_OPT_MODULUS        'm'
#define OPT_VALUE_MODULUS        (*(unsigned long*)(&DESC(MODULUS).pzLastArg))
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_PVT_CERT       'P'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_PVT_PASSWD     'p'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_GET_PVT_PASSWD 'q'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_SIGN_KEY       'S'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_SUBJECT_NAME   's'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_TRUSTED_CERT   'T'
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_MV_PARAMS      'V'
#define OPT_VALUE_MV_PARAMS      (*(unsigned long*)(&DESC(MV_PARAMS).pzLastArg))
#endif /* OPENSSL */
#ifdef OPENSSL
#define VALUE_OPT_MV_KEYS        'v'
#define OPT_VALUE_MV_KEYS        (*(unsigned long*)(&DESC(MV_KEYS).pzLastArg))
#endif /* OPENSSL */

#define VALUE_OPT_VERSION       'v'
#define VALUE_OPT_SAVE_OPTS     '>'
#define VALUE_OPT_LOAD_OPTS     '<'
#define VALUE_OPT_HELP          '?'
#define VALUE_OPT_MORE_HELP     '!'
#define SET_OPT_SAVE_OPTS(a)   STMTS( \
        DESC(SAVE_OPTS).fOptState &= OPTST_PERSISTENT; \
        DESC(SAVE_OPTS).fOptState |= OPTST_SET; \
        DESC(SAVE_OPTS).pzLastArg  = (const char*)(a) )
/*
 *  Interface defines not associated with particular options
 */
#define ERRSKIP_OPTERR  STMTS( ntp_keygenOptions.fOptSet &= ~OPTPROC_ERRSTOP )
#define ERRSTOP_OPTERR  STMTS( ntp_keygenOptions.fOptSet |= OPTPROC_ERRSTOP )
#define RESTART_OPT(n)  STMTS( \
                ntp_keygenOptions.curOptIdx = (n); \
                ntp_keygenOptions.pzCurOpt  = NULL )
#define START_OPT       RESTART_OPT(1)
#define USAGE(c)        (*ntp_keygenOptions.pUsageProc)( &ntp_keygenOptions, c )
/* extracted from opthead near line 289 */

/* * * * * *
 *
 *  Declare the ntp-keygen option descriptor.
 */
#ifdef  __cplusplus
extern "C" {
#endif

extern tOptions   ntp_keygenOptions;

#ifndef _
#  if ENABLE_NLS
#    include <stdio.h>
     static inline char* aoGetsText( const char* pz ) {
         if (pz == NULL) return NULL;
         return (char*)gettext( pz );
     }
#    define _(s)  aoGetsText(s)
#  else  /* ENABLE_NLS */
#    define _(s)  s
#  endif /* ENABLE_NLS */
#endif

#ifdef  __cplusplus
}
#endif
#endif /* AUTOOPTS_NTP_KEYGEN_OPTS_H_GUARD */
/*
 * Local Variables:
 * Mode: C
 * c-file-style: "stroustrup"
 * indent-tabs-mode: nil
 * End:
 * options.h ends here */
